#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#define suid
#define QUOTE '\\'
#define WILDS '*'
#define WILDP '%'
#define WILDQ '?'
#define WILDT '~'
#ifndef suid
#undef WILDT
#endif
#define MATCH (match+saved+sofar)
#define NOMATCH 0
#ifdef suid
static int wild_match_per(register unsigned char *m, register unsigned char *n)
#else
int wild_match(register unsigned char *m, register unsigned char *n)
#endif
{
  unsigned char *ma = m, *lsm = 0, *lsn = 0, *lpm = 0, *lpn = 0;
  int match = 1, saved = 0;
  register unsigned int sofar = 0;

#ifdef WILDT
  int space;
#endif
  if ((m == 0) || (n == 0) || (!*n))
    return NOMATCH;
  while (*n) {
#ifdef WILDT
    if (*m == WILDT) {
      space = 0;
      do {
	m++;
	space++;
      }	
      while ((*m == WILDT) || (*m == ' '));
      sofar += space;
      while (*n == ' ') {
	n++;
	space--;
      }	
      if (space <= 0)
	continue;
    }
    else {
#endif
      switch (*m) {
      case 0:
	do
	  m--;
	while ((m > ma) && (*m == '?'));
	if ((m > ma) ? ((*m == '*') && (m[-1] != QUOTE)) : (*m == '*'))
	  return MATCH;
	break;
      case WILDP:
	while (*(++m) == WILDP);
	if (*m != WILDS) {
	  if (*n != ' ') {
	    lpm = m;
	    lpn = n;
	    saved += sofar;
	    sofar = 0;
	  }
	  continue;
	}
      case WILDS:
	do
	  m++;
	while ((*m == WILDS) || (*m == WILDP));
	lsm = m;
	lsn = n;
	lpm = 0;
	match += (saved + sofar);
	saved = sofar = 0;
	continue;
      case WILDQ:
	m++;
	n++;
	continue;
      case QUOTE:
	m++;
      }
      if (rfc_toupper(*m) == rfc_toupper(*n)) {
	m++;
	n++;
	sofar++;
	continue;
      }
#ifdef WILDT
    }
#endif
    if (lpm) {
      n = ++lpn;
      m = lpm;
      sofar = 0;
      if ((*n | 32) == 32)
	lpm = 0;
      continue;
    }
    if (lsm) {
      n = ++lsn;
      m = lsm;
      saved = sofar = 0;
      continue;
    }
    return NOMATCH;
  }
  while ((*m == WILDS) || (*m == WILDP))
    m++;
  return (*m) ? NOMATCH : MATCH;
}

#ifndef suid


int _wild_match(ma, na)
register unsigned char *ma, *na;
{
  return wild_match(ma, na) - 1;
}

int match(ma, na)
register unsigned char *ma, *na;
{
  return wild_match(ma, na) ? 1 : 0;
}

#else
#define UNQUOTED (0x7FFF)
#define QUOTED   (0x8000)
#undef MATCH
#define MATCH ((match+sofar)&UNQUOTED)

int _wild_match(register unsigned char *m, register unsigned char *n)
{
  unsigned char *ma = m, *na = n, *lsm = 0, *lsn = 0;
  int match = 1;
  register int sofar = 0;

  if ((ma == 0) || (na == 0) || (!*ma) || (!*na))
    return NOMATCH;
  while (*(++m));
    m--;
  while (*(++n));
    n--;

  while (n >= na) {
    if ((m <= ma) || (m[-1] != QUOTE)) {
      switch (*m) {
      case WILDS:
	do
	  m--;
	while ((m >= ma) && ((*m == WILDS) || (*m == WILDP)));
	if ((m >= ma) && (*m == '\\'))
	  m++;
	lsm = m;
	lsn = n;
	match += sofar;
	sofar = 0;
	continue;
      case WILDQ:
	m--;
	n--;
	continue;
      }
      sofar &= UNQUOTED;
    } else
      sofar |= QUOTED;
    if (rfc_toupper(*m) == rfc_toupper(*n)) {
      m--;
      n--;
      sofar++;
      if (sofar & QUOTED)
	m--;
      continue;
    }
    if (lsm) {	
      n = --lsn;
      m = lsm;
      if (n < na)
	lsm = 0;
      sofar = 0;
      continue;	
    }
    return NOMATCH;
  }
  while ((m >= ma) && ((*m == WILDS) || (*m == WILDP)))
    m--;
  return (m >= ma) ? NOMATCH : MATCH;
}

#endif
