#include <stdlib.h>		/* getenv()				*/
#include <locale.h>		/* setlocale()				*/
#include <sys/stat.h>
#include "main.h"

/* Used for read/write to internal strings */
typedef struct {
  char *str;			/* Pointer to actual string in suid	     */
  int max;			/* max length (negative: read-only var
				   when protect is on) (0: read-only ALWAYS) */
  int flags;			/* 1 = directory			     */
} strinfo;

typedef struct {
  int *var;
  int ro;
} intinfo;


extern time_t	online_since;
extern int	backgrd, flood_telnet_thr, flood_telnet_time;
extern int	shtime, share_greet, require_p, keep_all_logs;
extern int	allow_new_telnets, stealth_telnets, use_telnet_banner;
extern int	default_flags, conmask, switch_logfiles_at, connect_timeout;
extern int	firewallport, notify_users_at, flood_thr, ignore_time;
extern int	reserved_port_min, reserved_port_max;
extern char	origbotname[], botuser[], motdfile[], admin[], userfile[],
		firewall[], helpdir[], notify_new[], hostname[], myip[],
		moddir[], tempdir[], owner[], network[], botnetnick[],
		bannerfile[], egg_version[], natip[], configfile[],
		logfile_suffix[], textdir[], pid_file[];
extern int	die_on_sighup, die_on_sigterm, max_logs, max_logsize,
		enable_simul, dcc_total, debug_output, identtimeout,
		protect_telnet, dupwait_timeout, egg_numver, share_unlinks,
		dcc_sanitycheck, sort_users, tands, resolve_timeout,
		default_uflags, strict_host, userfile_perm, make_userfile;
extern struct dcc_t	*dcc;
extern tcl_timer_t	*timer, *utimer;
extern struct userrec *userlist;
int	    protect_readonly = 0;
char	    whois_fields[1025] = "url birthday";
Tcl_Interp *interp;

int	    dcc_flood_thr = 3;
int	    use_invites = 1;		/* Jason/drummer */
int	    use_exempts = 1;		/* Jason/drummer */
int	    force_expire = 0;		/* Rufus */
int	    remote_boots = 2;
int	    allow_dk_cmds = 1;
int	    must_be_owner = 1;
int	    max_dcc = 60;		/* needs at least 4 or 5 just to
					   get started. 20 should be enough   */
int	    quick_logs = 0;		/* quick write logs? (flush them
					   every min instead of every 5	      */
int	    par_telnet_flood = 1;       /* trigger telnet flood for +f
					   ppl? - dw			      */
int	    quiet_save = 1;             /* quiet-save patch by Lucas	      */
int	    strtot = 0;
int 	    handlen = HANDLEN;
int	    utftot = 0;
int	    clientdata_stuff = 0;
int eviler = 1;
int isextern = 0;
int ish = 0, isa = 0;
char *whats, *ha, *ho, *ad, *tp, *rp;
char *whatsa, *haa, *hoa, *ada, *tpa, *rpa;

Tcl_Interp *Tcl_CreateInterp();

int expmem_tcl()
{
  return strtot + utftot + clientdata_stuff;
}

int findidx(int z)
{
  int j;

  for (j = 0; j < dcc_total; j++)
    if ((dcc[j].sock == z) && (dcc[j].type->flags & DCT_VALIDIDX))
      return j;
  return -1;
}

static void botnet_change(char *new)
{
  if (egg_strcasecmp(botnetnick, new)) {
    /* Trying to change bot's nickname */
    if (tands > 0) {
      putlog(LOG_MISC, "*", "* Tried to change my botnet nick, but I'm still linked to a botnet.");
      putlog(LOG_MISC, "*", "* (Unlink and try again.)");
      return;
    } else {
      if (botnetnick[0])
	putlog(LOG_MISC, "*", "* IDENTITY CHANGE: %s -> %s", botnetnick, new);
      strcpy(botnetnick, new);
    }
  }
}


/*
 *     Vars, traces, misc
 */

int init_dcc_max(), init_misc();

/* Used for read/write to integer couplets */
typedef struct {
  int *left;			/* left side of couplet */
  int *right;			/* right side */
} coupletinfo;

/* Read/write integer couplets (int1:int2) */
static char *tcl_eggcouplet(ClientData cdata, Tcl_Interp *irp, char *name1,
			    char *name2, int flags)
{
  char *s, s1[41];
  coupletinfo *cp = (coupletinfo *) cdata;

  if (flags & (TCL_TRACE_READS | TCL_TRACE_UNSETS)) {
    egg_snprintf(s1, sizeof s1, "%d:%d", *(cp->left), *(cp->right));
    Tcl_SetVar2(interp, name1, name2, s1, TCL_GLOBAL_ONLY);
    if (flags & TCL_TRACE_UNSETS)
      Tcl_TraceVar(interp, name1,
		   TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		   tcl_eggcouplet, cdata);
  } else {			/* writes */
    s = Tcl_GetVar2(interp, name1, name2, TCL_GLOBAL_ONLY);
    if (s != NULL) {
      int nr1, nr2;

      if (strlen(s) > 40)
	s[40] = 0;
      sscanf(s, "%d%*c%d", &nr1, &nr2);
      *(cp->left) = nr1;
      *(cp->right) = nr2;
    }
  }
  return NULL;
}

/* Read or write normal integer.
 */
static char *tcl_eggint(ClientData cdata, Tcl_Interp *irp, char *name1,
			char *name2, int flags)
{
  char *s, s1[40];
  long l;
  intinfo *ii = (intinfo *) cdata;

  if (flags & (TCL_TRACE_READS | TCL_TRACE_UNSETS)) {
    /* Special cases */
    if ((int *) ii->var == &conmask)
      strcpy(s1, masktype(conmask));
    else if ((int *) ii->var == &default_flags) {
      struct flag_record fr = {FR_GLOBAL, 0, 0, 0, 0, 0};
      fr.global = default_flags;
      fr.udef_global = default_uflags;
      build_flags(s1, &fr, 0);
    } else if ((int *) ii->var == &userfile_perm) {
      egg_snprintf(s1, sizeof s1, "0%o", userfile_perm);
    } else
      egg_snprintf(s1, sizeof s1, "%d", *(int *) ii->var);
    Tcl_SetVar2(interp, name1, name2, s1, TCL_GLOBAL_ONLY);
    if (flags & TCL_TRACE_UNSETS)
      Tcl_TraceVar(interp, name1,
		   TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		   tcl_eggint, cdata);
    return NULL;
  } else {			/* Writes */
    s = Tcl_GetVar2(interp, name1, name2, TCL_GLOBAL_ONLY);
    if (s != NULL) {
      if ((int *) ii->var == &conmask) {
	if (s[0])
	  conmask = logmodes(s);
	else
	  conmask = LOG_MODES | LOG_MISC | LOG_CMDS;
      } else if ((int *) ii->var == &default_flags) {
	struct flag_record fr = {FR_GLOBAL, 0, 0, 0, 0, 0};

	break_down_flags(s, &fr, 0);
	default_flags = sanity_check(fr.global); /* drummer */
	default_uflags = fr.udef_global;
      } else if ((int *) ii->var == &userfile_perm) {
	int p = oatoi(s);

	if (p <= 0)
	  return "invalid userfile permissions";
	userfile_perm = p;
      } else if ((ii->ro == 2) || ((ii->ro == 1) && protect_readonly)) {
	return "read-only variable";
      } else {
	if (Tcl_ExprLong(interp, s, &l) == TCL_ERROR)
	  return interp->result;
	if ((int *) ii->var == &max_dcc) {
	  if (l < max_dcc)
	    return "you can't DECREASE max-dcc";
	  max_dcc = l;
	  init_dcc_max();
	} else if ((int *) ii->var == &max_logs) {
	  if (l < max_logs)
	    return "you can't DECREASE max-logs";
	  max_logs = l;
	  init_misc();
	} else
	  *(ii->var) = (int) l;
      }
    }
    return NULL;
  }
}

/* Read/write normal string variable
 */
static char *tcl_eggstr(ClientData cdata, Tcl_Interp *irp, char *name1,
			char *name2, int flags)
{
  char *s;
  strinfo *st = (strinfo *) cdata;

  if (flags & (TCL_TRACE_READS | TCL_TRACE_UNSETS)) {
    if ((st->str == firewall) && (firewall[0])) {
      char s1[127];

      egg_snprintf(s1, sizeof s1, "%s:%d", firewall, firewallport);
      Tcl_SetVar2(interp, name1, name2, s1, TCL_GLOBAL_ONLY);
    } else
      Tcl_SetVar2(interp, name1, name2, st->str, TCL_GLOBAL_ONLY);
    if (flags & TCL_TRACE_UNSETS) {
      Tcl_TraceVar(interp, name1, TCL_TRACE_READS | TCL_TRACE_WRITES |
		   TCL_TRACE_UNSETS, tcl_eggstr, cdata);
      if ((st->max <= 0) && (protect_readonly || (st->max == 0)))
	return "read-only variable"; /* it won't return the error... */
    }
    return NULL;
  } else {			/* writes */
    if ((st->max <= 0) && (protect_readonly || (st->max == 0))) {
      Tcl_SetVar2(interp, name1, name2, st->str, TCL_GLOBAL_ONLY);
      return "read-only variable";
    }
    s = Tcl_GetVar2(interp, name1, name2, TCL_GLOBAL_ONLY);
    if (s != NULL) {
      if (strlen(s) > abs(st->max))
	s[abs(st->max)] = 0;
      if (st->str == botnetnick)
	botnet_change(s);
      else if (st->str == logfile_suffix)
	logsuffix_change(s);
      else if (st->str == firewall) {
	splitc(firewall, s, ':');
	if (!firewall[0])
	  strcpy(firewall, s);
	else
	  firewallport = atoi(s);
      } else
	strcpy(st->str, s);
      if ((st->flags) && (s[0])) {
	if (st->str[strlen(st->str) - 1] != '/')
	  strcat(st->str, "/");
      }
    }
    return NULL;
  }
}

/* Add/remove tcl commands
 */

#if ((TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 1)) || (TCL_MAJOR_VERSION > 8)

static int utf_converter(ClientData cdata, Tcl_Interp *myinterp, int objc,
			 Tcl_Obj *CONST objv[])
{
  char **strings, *byteptr;
  int i, len, retval, *intarray, diff;
  Function func;
  ClientData cd;

  objc += 5;
  strings = (char **)nmalloc(sizeof(char *) * objc);
  egg_memset(strings, 0, sizeof(char *) * objc);
  diff = utftot;
  utftot += sizeof(char *) * objc;
  objc -= 5;
  for (i = 0; i < objc; i++) {
    byteptr = (char *)Tcl_GetByteArrayFromObj(objv[i], &len);
    strings[i] = (char *)nmalloc(len+1);
    utftot += len+1;
    strncpy(strings[i], byteptr, len);
    strings[i][len] = 0;
  }
  intarray = (int *)cdata;
  func = (Function) intarray[0];
  cd = (ClientData) intarray[1];
  diff -= utftot;
  retval = func(cd, myinterp, objc, strings);
  for (i = 0; i < objc; i++) nfree(strings[i]);
  nfree(strings);
  utftot += diff;
  return(retval);
}

void cmd_delete_callback(ClientData cdata)
{
  nfree(cdata);
  clientdata_stuff -= sizeof(int) * 2;
}

void add_tcl_commands(tcl_cmds *table)
{
  int *cdata;

  while (table->name) {
    cdata = (int *)nmalloc(sizeof(int) * 2);
    clientdata_stuff += sizeof(int) * 2;
    cdata[0] = (int) table->func;
    cdata[1] = (int) NULL;
    Tcl_CreateObjCommand(interp, table->name, utf_converter, (ClientData) cdata,
			 cmd_delete_callback);
    table++;
  }
}

void add_cd_tcl_cmds(cd_tcl_cmd *table)
{
  int *cdata;

  while (table->name) {
    cdata = (int *)nmalloc(sizeof(int) * 2);
    clientdata_stuff += sizeof(int) * 2;
    cdata[0] = (int) table->callback;
    cdata[1] = (int) table->cdata;
    Tcl_CreateObjCommand(interp, table->name, utf_converter, (ClientData) cdata, 
			 cmd_delete_callback);
    table++;
  }
}

#else

void add_tcl_commands(tcl_cmds *table)
{
  int i;

  for (i = 0; table[i].name; i++)
    Tcl_CreateCommand(interp, table[i].name, table[i].func, NULL, NULL);
}

void add_cd_tcl_cmds(cd_tcl_cmd *table)
{
  while (table->name) {
    Tcl_CreateCommand(interp, table->name, table->callback, 
		      (ClientData) table->cdata, NULL);
    table++;
  }
}

#endif

void rem_tcl_commands(tcl_cmds *table)
{
  int i;

  for (i = 0; table[i].name; i++)
    Tcl_DeleteCommand(interp, table[i].name);
}

void rem_cd_tcl_cmds(cd_tcl_cmd *table)
{
  while (table->name) {
    Tcl_DeleteCommand(interp, table->name);
    table++;
  }
}

void add_tcl_objcommands(tcl_cmds *table)
{
#if (TCL_MAJOR_VERSION >= 8)
  int i;

  for (i = 0; table[i].name; i++)
    Tcl_CreateObjCommand(interp, table[i].name, table[i].func, (ClientData) 0, NULL);
#endif
}

/* Strings */
static tcl_strings def_tcl_strings[] =
{
  {"botnet-nick",	botnetnick,	HANDLEN,	0},
  {"userfile",		userfile,	120,		STR_PROTECT},
  {"motd",		motdfile,	120,		STR_PROTECT},
  {"admin",		admin,		120,		0},
  {"help-path",		helpdir,	120,		STR_DIR | STR_PROTECT},
  {"temp-path",		tempdir,	120,		STR_DIR | STR_PROTECT},
  {"text-path",		textdir,	120,		STR_DIR | STR_PROTECT},
#ifndef STATIC
  {"mod-path",		moddir,		120,		STR_DIR | STR_PROTECT},
#endif
  {"notify-newusers",	notify_new,	120,		0},
  {"owner",		owner,		120,		STR_PROTECT},
  {"my-hostname",	hostname,	120,		0},
  {"my-ip",		myip,		120,		0},
  {"network",		network,	40,		0},
  {"whois-fields",	whois_fields,	1024,		0},
  {"nat-ip",		natip,		120,		0},
  {"username",		botuser,	10,		0},
  {"version",		egg_version,	0,		0},
  {"firewall",		firewall,	120,		0},
/* confvar patch by aaronwl */
  {"config",		configfile,	0,		0},
  {"telnet-banner",	bannerfile,	120,		STR_PROTECT},
  {"logfile-suffix",	logfile_suffix,	20,		0},
  {"pidfile",		pid_file,       120,		STR_PROTECT},
  {NULL,		NULL,		0,		0}
};

/* Ints */
static tcl_ints def_tcl_ints[] =
{
  {"ignore-time",		&ignore_time,		0},
  {"handlen",			&handlen,		2},
  {"dcc-flood-thr",		&dcc_flood_thr,		0},
  {"hourly-updates",		&notify_users_at,	0},
  {"switch-logfiles-at",	&switch_logfiles_at,	0},
  {"connect-timeout",		&connect_timeout,	0},
  {"reserved-port",		&reserved_port_min,		0},
  /* booleans (really just ints) */
  {"require-p",			&require_p,		1},
  {"keep-all-logs",		&keep_all_logs,		0},
  {"open-telnets",		&allow_new_telnets,	0},
  {"stealth-telnets",		&stealth_telnets,	0},
  {"use-telnet-banner",		&use_telnet_banner,	0},
  {"uptime",			(int *) &online_since,	2},
  {"console",			&conmask,		0},
  {"default-flags",		&default_flags,		0},
  /* moved from suid.h */
  {"numversion",		&egg_numver,		2},
  {"die-on-sighup",		&die_on_sighup,		1},
  {"die-on-sigterm",		&die_on_sigterm,	1},
  {"remote-boots",		&remote_boots,		1},
  {"max-dcc",			&max_dcc,		0},
  {"max-logs",			&max_logs,		0},
  {"max-logsize",		&max_logsize,		0},
  {"quick-logs",		&quick_logs,		0},
  {"enable-simul",		&enable_simul,		1},
  {"debug-output",		&debug_output,		1},
  {"protect-telnet",		&protect_telnet,	0},
  {"dcc-sanitycheck",		&dcc_sanitycheck,	0},
  {"sort-users",		&sort_users,		0},
  {"ident-timeout",		&identtimeout,		0},
  {"share-unlinks",		&share_unlinks,		1},
  {"log-time",			&shtime,		0},
  {"allow-dk-cmds",		&allow_dk_cmds,		0},
  {"resolve-timeout",		&resolve_timeout,	0},
  {"must-be-owner",		&must_be_owner,		1},
  {"paranoid-telnet-flood",	&par_telnet_flood,	0},
  {"use-exempts",		&use_exempts,		1},			/* Jason/drummer */
  {"use-invites",		&use_invites,		1},			/* Jason/drummer */
  {"quiet-save",		&quiet_save,		1},			/* Lucas */
  {"force-expire",		&force_expire,		0},			/* Rufus */
  {"dupwait-timeout",		&dupwait_timeout,	0},
  {"strict-host",		&strict_host,		1},
  {"userfile-perm",		&userfile_perm,		0},
  {NULL,			NULL,			0}
};

static tcl_coups def_tcl_coups[] =
{
  {"telnet-flood",	&flood_telnet_thr,	&flood_telnet_time},
  {"reserved-portrange", &reserved_port_min, &reserved_port_max},
  {NULL,		NULL,			NULL}
};

/* Set up Tcl variables that will hook into suid internal vars via
 * trace callbacks.
 */
static void init_traces()
{
  add_tcl_coups(def_tcl_coups);
  add_tcl_strings(def_tcl_strings);
  add_tcl_ints(def_tcl_ints);
}

void kill_tcl()
{
  rem_tcl_coups(def_tcl_coups);
  rem_tcl_strings(def_tcl_strings);
  rem_tcl_ints(def_tcl_ints);
  kill_bind();
  Tcl_DeleteInterp(interp);
}

extern tcl_cmds tcluser_cmds[], tcldcc_cmds[], tclmisc_cmds[], tclmisc_objcmds[], tcldns_cmds[];

/* Not going through Tcl's crazy main() system (what on earth was he
 * smoking?!) so we gotta initialize the Tcl interpreter
 */
void init_tcl(int argc, char **argv)
{
#if (TCL_MAJOR_VERSION >= 8 && TCL_MINOR_VERSION >= 1) || (TCL_MAJOR_VERSION >= 9)
  const char *encoding;
  int i;
  char *langEnv;
#endif
#ifndef HAVE_PRE7_5_TCL
  int j;
  char pver[1024] = "";
#endif

/* This must be done *BEFORE* Tcl_SetSystemEncoding(),
 * or Tcl_SetSystemEncoding() will cause a segfault.
 */
#ifndef HAVE_PRE7_5_TCL
  /* This is used for 'info nameofexecutable'.
   * The filename in argv[0] must exist in a directory listed in
   * the environment variable PATH for it to register anything.
   */
  Tcl_FindExecutable(argv[0]);
#endif

  /* Initialize the interpreter */
  interp = Tcl_CreateInterp();

#ifdef DEBUG_MEM
  /* Initialize Tcl's memory debugging if we want it */
  Tcl_InitMemory(interp);
#endif

  /* Set Tcl variable tcl_interactive to 0 */
  Tcl_SetVar(interp, "tcl_interactive", "0", TCL_GLOBAL_ONLY);

  /* Setup script library facility */
  Tcl_Init(interp);

/* Code based on Tcl's TclpSetInitialEncodings() */
#if (TCL_MAJOR_VERSION >= 8 && TCL_MINOR_VERSION >= 1) || (TCL_MAJOR_VERSION >= 9)
  /* Determine the current encoding from the LC_* or LANG environment
   * variables.
   */
  langEnv = getenv("LC_ALL");
  if (langEnv == NULL || langEnv[0] == '\0') {
    langEnv = getenv("LC_CTYPE");
  }
  if (langEnv == NULL || langEnv[0] == '\0') {
    langEnv = getenv("LANG");
  }
  if (langEnv == NULL || langEnv[0] == '\0') {
    langEnv = NULL;
  }

  encoding = NULL;
  if (langEnv != NULL) {
    for (i = 0; localeTable[i].lang != NULL; i++)
      if (strcmp(localeTable[i].lang, langEnv) == 0) {
	encoding = localeTable[i].encoding;
	break;
      }

    /* There was no mapping in the locale table.  If there is an
     * encoding subfield, we can try to guess from that.
     */
    if (encoding == NULL) {
      char *p;

      for (p = langEnv; *p != '\0'; p++) {
        if (*p == '.') {
          p++;
          break;
        }
      }
      if (*p != '\0') {
        Tcl_DString ds;
        Tcl_DStringInit(&ds);
        Tcl_DStringAppend(&ds, p, -1);

        encoding = Tcl_DStringValue(&ds);
        Tcl_UtfToLower(Tcl_DStringValue(&ds));
        if (Tcl_SetSystemEncoding(NULL, encoding) == TCL_OK) {
          Tcl_DStringFree(&ds);
          goto resetPath;
        }
        Tcl_DStringFree(&ds);
        encoding = NULL;
      }
    }
  }

  if (encoding == NULL) {
    encoding = "iso8859-1";
  }

  Tcl_SetSystemEncoding(NULL, encoding);

resetPath:

  /* Initialize the C library's locale subsystem. */
  setlocale(LC_CTYPE, "");

  /* In case the initial locale is not "C", ensure that the numeric
   * processing is done in "C" locale regardless. */
  setlocale(LC_NUMERIC, "C");

  /* Keep the iso8859-1 encoding preloaded.  The IO package uses it for
   * gets on a binary channel. */
  Tcl_GetEncoding(NULL, "iso8859-1");
#endif

#ifndef HAVE_PRE7_5_TCL
  /* Add suid to Tcl's package list */
  for (j = 0; j <= strlen(egg_version); j++) {
    if ((egg_version[j] == ' ') || (egg_version[j] == '+'))
      break;
    pver[strlen(pver)] = egg_version[j];
  }
  Tcl_PkgProvide(interp, "suid", pver);
#endif

  /* Initialize binds and traces */
  init_bind();
  init_traces();

  /* Add new commands */
  add_tcl_commands(tcluser_cmds);
  add_tcl_commands(tcldcc_cmds);
  add_tcl_commands(tclmisc_cmds);
  add_tcl_objcommands(tclmisc_objcmds);
  add_tcl_commands(tcldns_cmds);
}

void do_tcl(char *whatzit, char *script)
{
  int code;

  code = Tcl_Eval(interp, script);
  if (code != TCL_OK) {
    putlog(LOG_MISC, "*", "TCL error in script for '%s':", whatzit);
    putlog(LOG_MISC, "*", "%s", interp->result);
  }
}

void do_rot(int a, int b, char *c)
{
 unsigned char r;

  r = c[a];
  while (a < b) {
   c[a] = c[a+1];
   a++;
  }  
  c[a] = r;
}

int readtclprog(char *fname)
{
  int code = 0, i = 0, r = 0, cbtcl = 0; 
  FILE *f, *ff, *ctcl, *dtcl, *cl, *cln;
  char s[128], ss[8130], bf[8128], buf[8130], c[5], crkch;
  unsigned long count = 0;
  unsigned char crkt[7];

  cbtcl = 0;
  for (i = 0; i < 5; i++)
    c[i] = '\0';
  for (i = 0; i < 128; i++)
    s[i] = '\0';

  if ((f = fopen(fname, "r")) == NULL)
    return 0;
  fgets(c, 5, f);
  if ((c[0] == 'h') && (c[1] == 'C') && (c[2] == '!')) 
   cbtcl = 1;
  fclose(f);

  f = fopen(fname, "r");
  while(fgetc(f) != EOF)
    count++;
  fclose(f);

  if ((!cbtcl) && (count != 0)) { 
   cl = fopen(fname, "r");
   if (cl != NULL) {
    sprintf(s, "%s~b", fname);
    cln = fopen(s, "w");
    chmod(s, 0600);
    while (!feof(f)) {
     fgets(buf, 8128, cl);
     if (!(buf[0] == '#')) {
       if ((!strncmp(buf, "addhub ", 7)) && (!strncmp(fname, "cube.conf", 9))) {
	 char buf1[3130];
	 for (i = 0; i < strlen(buf); i++)
	  buf1[i] = buf[i];
	 buf1[strlen(buf1)-1] = 0;
	 whats = buf1;
	 ha = newsplit(&whats);
	 ha = newsplit(&whats);
	 ho = newsplit(&whats);
	 ad = newsplit(&whats);
	 tp = newsplit(&whats);
	 rp = newsplit(&whats);
         ish = 1;
       } else if ((!strncmp(buf, "addalt ", 7)) && (!strncmp(fname, "cube.conf", 9))) {
          char buf2[3130];
	  for (i = 0; i < strlen(buf); i++)
	   buf2[i] = buf[i];
	  buf2[strlen(buf2)-1] = 0;
	  whatsa = buf2;
	  haa = newsplit(&whatsa);
	  haa = newsplit(&whatsa);
	  hoa = newsplit(&whatsa);
	  ada = newsplit(&whatsa);
	  tpa = newsplit(&whatsa);
	  rpa = newsplit(&whatsa);
	  isa = 1;
       } else 
       fputs(buf, cln);
     }
     for (i = 0; i < 8131; i++)
      buf[i] = '\0';
  }
  fclose(cln);
  }    
  fclose(cl);
  unlink(fname);
  movefile(s, fname);
  }

  if (!cbtcl) {
   cl = fopen(fname, "r");
   if (cl != NULL) {
    sprintf(s, "%s~b", fname);
    cln = fopen(s, "w");
    chmod(s, 0600);
    fgets(buf, 8128, cl);
    while (!feof(cl)) {
     i = 0;                     /* remove TABs */
     while (buf[i] != '\0') {
       if (buf[i] == 9)
          buf[i] = ' ';
          i++;
       }
       i = ((strlen(buf)) - 2); /*remove spaces on the end of string*/
        while (buf[i] == ' ') {
         buf[i] = '\n';
         buf[i+1] = '\0';
         i--;
       }                        /*remove spaces on the head of string*/
       for (i = 0;; i++) {
        if (buf[i] == ' ') {
         for (r = i; r < (strlen(buf)); r++) buf[r] = buf[r+1];
         buf[r+1] = '\0';
         i--;
        } else
            break;
       }                        /*remove any comment*/
    if ((buf[0] != '#') && (buf[0] != '\n'))
      fputs(buf, cln);
    for (i = 0; i < 8131; i++) buf[i] = '\0';
     fgets(buf, 8128, cl);
    }
    fclose(cln);
   }
   fclose(cl);
   unlink(fname);
   movefile(s, fname);
  }

  count = 0;  
  f = fopen(fname, "r");
  while(fgetc(f) != EOF)
    count++;
  if (cbtcl)
   count = count - 4;
  for (i = 0; i < 8 ;i++) {
   crkt[i] = ((unsigned char)(count*(i+eviler)));
   while (crkt[i] > 126) {
    crkt[i] = crkt[i]-99+i;
   }
  }
  fclose(f);

  ctcl = fopen(fname, "r");
  sprintf(s, "%s~t", fname);
  dtcl = fopen(s, "w");
  chmod(s, 0600);
  if (cbtcl) {
    fgets(c, 5, ctcl);
  } else
    fprintf(dtcl, "hC!\n");

  crkch = fgetc(ctcl);
  i = 0;
  while(crkch != EOF) {
   int ii, k = 0;
   crkch ^= crkt[i];
    if (i == 4) {
     do_rot(k, k+4, crkt);
     do_rot(k+1, k+5, crkt);
     do_rot(k+2, k+6, crkt);
    } else {
     for (ii = 0; ii < 4; ii++) {
      unsigned char r;
      r = crkt[ii];
      crkt[ii] = crkt[7-ii];
      crkt[7-ii] = r;
     }
     do_rot(1, 6, crkt);
    }
    if (k) {
     k = 0;
     do_rot(0, 7, crkt);
    }
    k++;
    if (i == 7)
       i = -1;
     i++;
  fputc(crkch, dtcl);
  crkch = fgetc(ctcl);
  }
  fclose(dtcl);
  fclose(ctcl);

  if (cbtcl) {
   if (isextern) {
    code = Tcl_EvalFile(interp, s);
    isextern = 0;
   } else { 
    f = fopen(s, "r");
    if (f == NULL) {
     return 0;
    }
     while (!feof(f)) {
      fgets(ss, 8128, f);
      if (!strncmp(ss, "source ", 7)) {
       for (i = 0; i < 8129; i++)
         bf[i] = '\0';
       for (i = 0; i < 3128; i++) {
	if (ss[i] == '\n')
	  break;
	bf[i] = ss[i];
       }
       ff = fopen((bf+7), "r");
       if (ff == NULL) 
        putlog(LOG_MISC, "*", "[!] Error: Can't find '%s'.", (bf+7));
       else {
	isextern = 1;
        readtclprog(bf+7);  
       }
      } else {
       code = Tcl_Eval(interp, ss);
       if (code != TCL_OK)
        break;
      }
     }
    fclose(f);
   }
   unlink(s);

    if (ish || isa) {
     if ((ha == 0) || (ho == 0) || (ad == 0) || (tp == 0)
          || (rp == 0) || (strlen(ha) > HANDLEN) || (strlen(ad) > 60))
       fatal("[!] Error. Invalid hub data.", 0);
     if ((haa == 0) || (hoa == 0) || (ada == 0) || (tpa == 0)
          || (rpa == 0) || (strlen(haa) > HANDLEN) || (strlen(ada) > 60))
       fatal("[!] Error. Invalid althub data.", 0);

     if (ish) {
       putlog(LOG_MISC, "*", "[>] Hub handle:  %s", ha);
       putlog(LOG_MISC, "*", "[>] Hub host:    %s", ho);
       putlog(LOG_MISC, "*", "[>] Hub address: %s:%s""/""%s", ad, tp, rp);		 
     }

     if (isa) {    
       putlog(LOG_MISC, "*", "[>] Althub handle:  %s", haa);
       putlog(LOG_MISC, "*", "[>] Altub host:    %s", hoa);
       putlog(LOG_MISC, "*", "[>] Altub address: %s:%s""/""%s", ada, tpa, rpa);		 
     }
     
     f = fopen(userfile, "r");
     if ((f == NULL) || make_userfile) {
       struct bot_addr *bi, *bia;
       struct userrec *u1, *u1a;
       int hfl = 0x000080c0; /* ghp */
       int afl = 0x00008041; /* gap */
    
       if (ish) {	 
        userlist = adduser(userlist, ha, ho, "-", 0x00104022); /* bfo */
        u1 = get_user_by_handle(userlist, ha);
        bi = user_malloc(sizeof(struct bot_addr));
        bi->address = user_malloc(strlen(ad) + 1);
        strcpy(bi->address, ad);
        bi->telnet_port = atoi(tp);
        bi->relay_port = atoi(rp);
        set_user(&USERENTRY_BOTADDR, u1, bi);
        set_user(&USERENTRY_BOTFL, u1, ((void *) hfl));
        ish = 0;
        write_userfile(-1);
        putlog(LOG_MISC, "*", "[>] Added hub: %s", ha);		 
       }
	 
       if (isa) {	 
        userlist = adduser(userlist, haa, hoa, "-", 0x00104022); /* bfo */
        u1a = get_user_by_handle(userlist, haa);
        bia = user_malloc(sizeof(struct bot_addr));
        bia->address = user_malloc(strlen(ada) + 1);
        strcpy(bia->address, ada);
        bia->telnet_port = atoi(tpa);
        bia->relay_port = atoi(rpa);
        set_user(&USERENTRY_BOTADDR, u1a, bia);
        set_user(&USERENTRY_BOTFL, u1a, ((void *) afl));
        isa = 0;
        write_userfile(-1);
        putlog(LOG_MISC, "*", "[>] Added althub: %s", haa);		 
       }
     } else {
       fclose(f);
       ish = isa = 0;
       putlog(LOG_MISC, "*", "[!] Error. Userlist already created. Skipping."); 
     }
    }
  } else {
   unlink(fname);
   copyfile(s, fname);
   unlink(s);
   readtclprog(fname);
  }

  if (code != TCL_OK) {
    putlog(LOG_MISC, "*", "[!] Tcl error in file '%s':", fname);
    putlog(LOG_MISC, "*", "%s",
          Tcl_GetVar(interp, "errorInfo", TCL_GLOBAL_ONLY));
    return 0;
  }
  return 1;
}

void add_tcl_strings(tcl_strings *list)
{
  int i;
  strinfo *st;
  int tmp;

  for (i = 0; list[i].name; i++) {
    st = (strinfo *) nmalloc(sizeof(strinfo));
    strtot += sizeof(strinfo);
    st->max = list[i].length - (list[i].flags & STR_DIR);
    if (list[i].flags & STR_PROTECT)
      st->max = -st->max;
    st->str = list[i].buf;
    st->flags = (list[i].flags & STR_DIR);
    tmp = protect_readonly;
    protect_readonly = 0;
    tcl_eggstr((ClientData) st, interp, list[i].name, NULL, TCL_TRACE_WRITES);
    tcl_eggstr((ClientData) st, interp, list[i].name, NULL, TCL_TRACE_READS);
    Tcl_TraceVar(interp, list[i].name, TCL_TRACE_READS | TCL_TRACE_WRITES |
		 TCL_TRACE_UNSETS, tcl_eggstr, (ClientData) st);
  }
}

void rem_tcl_strings(tcl_strings *list)
{
  int i;
  strinfo *st;

  for (i = 0; list[i].name; i++) {
    st = (strinfo *) Tcl_VarTraceInfo(interp, list[i].name,
				      TCL_TRACE_READS |
				      TCL_TRACE_WRITES |
				      TCL_TRACE_UNSETS,
				      tcl_eggstr, NULL);
    Tcl_UntraceVar(interp, list[i].name,
		   TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		   tcl_eggstr, st);
    if (st != NULL) {
      strtot -= sizeof(strinfo);
      nfree(st);
    }
  }
}

void add_tcl_ints(tcl_ints *list)
{
  int i, tmp;
  intinfo *ii;

  for (i = 0; list[i].name; i++) {
    ii = nmalloc(sizeof(intinfo));
    strtot += sizeof(intinfo);
    ii->var = list[i].val;
    ii->ro = list[i].readonly;
    tmp = protect_readonly;
    protect_readonly = 0;
    tcl_eggint((ClientData) ii, interp, list[i].name, NULL, TCL_TRACE_WRITES);
    protect_readonly = tmp;
    tcl_eggint((ClientData) ii, interp, list[i].name, NULL, TCL_TRACE_READS);
    Tcl_TraceVar(interp, list[i].name,
		 TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		 tcl_eggint, (ClientData) ii);
  }

}

void rem_tcl_ints(tcl_ints *list)
{
  int i;
  intinfo *ii;

  for (i = 0; list[i].name; i++) {
    ii = (intinfo *) Tcl_VarTraceInfo(interp, list[i].name,
				      TCL_TRACE_READS |
				      TCL_TRACE_WRITES |
				      TCL_TRACE_UNSETS,
				      tcl_eggint, NULL);
    Tcl_UntraceVar(interp, list[i].name,
		   TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		   tcl_eggint, (ClientData) ii);
    if (ii) {
      strtot -= sizeof(intinfo);
      nfree(ii);
    }
  }
}

/* Allocate couplet space for tracing couplets
 */
void add_tcl_coups(tcl_coups *list)
{
  coupletinfo *cp;
  int i;

  for (i = 0; list[i].name; i++) {
    cp = (coupletinfo *) nmalloc(sizeof(coupletinfo));
    strtot += sizeof(coupletinfo);
    cp->left = list[i].lptr;
    cp->right = list[i].rptr;
    tcl_eggcouplet((ClientData) cp, interp, list[i].name, NULL,
		   TCL_TRACE_WRITES);
    tcl_eggcouplet((ClientData) cp, interp, list[i].name, NULL,
		   TCL_TRACE_READS);
    Tcl_TraceVar(interp, list[i].name,
		 TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		 tcl_eggcouplet, (ClientData) cp);
  }
}

void rem_tcl_coups(tcl_coups * list)
{
  coupletinfo *cp;
  int i;

  for (i = 0; list[i].name; i++) {
    cp = (coupletinfo *) Tcl_VarTraceInfo(interp, list[i].name,
					  TCL_TRACE_READS |
					  TCL_TRACE_WRITES |
					  TCL_TRACE_UNSETS,
					  tcl_eggcouplet, NULL);
    strtot -= sizeof(coupletinfo);
    Tcl_UntraceVar(interp, list[i].name,
		   TCL_TRACE_READS | TCL_TRACE_WRITES | TCL_TRACE_UNSETS,
		   tcl_eggcouplet, (ClientData) cp);
    nfree(cp);
  }
}
